//+------------------------------------------------------------------+
//|                                                +DLLIndexNorm.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//
#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Red         // Index USD 
#property indicator_color2 Gold        // Index EUR 
#property indicator_color3 Chartreuse  // Index GBP 
#property indicator_color4 Aqua        // Index CHF 
#property indicator_color5 Magenta     // Index JPY 
//
// DLL -  ;   . 
#import "index.dll"
  int    MakeIndex ( double point_, int nsize_, double pairs_ [ ], int cmeth_ );
  double GetAIndex ( int    ipos_ ); // *) ; . 
  double GetFValue ( );              // *) . 
  int    GetNNIter ( );              // *) . 
#import
//
// DLL -     , ..  , 
//       ...,      ...: ( x [.] - mean ) / sigma -> x [.]; 
//         . 
#import "normarray.dll"
  void   ArrSmtNorm ( double point_, int nsize_, double array_ [ ], int smmode_, int mvmode_ );
  double GetVSmooth ( int    ipos_ ); // *) ; . 
  double GetVNormal ( int    ipos_ ); // *) ; . 
  double GetMeanVal ( );              // *) . 
  double GetDStdDev ( );              // *) . 
#import
//
// *) :         DLL,
//          x-protector'   ,
//     ,  ,     
//      ;   -  .  -
//       DLL      ,  x-protector
//              
//       (      
//      ),       .
//             DLL 
//        x-protector',    .
//
// ---- input parameters
// ----
extern double ValPoint = 0.00001; //   - 1     ;
// ----
extern int    HistBars =     300; //      ;
// ----
extern int    Interval =      15; //    (  );
// ----
extern int    SmthMode =       1; //    : 
                                  // -1 -   ;
                                  //  0 -   
                                  //       3-     ;
                                  //  1 -   
                                  //       3-     ;
                                  //  2 -   
                                  //       3-     ;
// ----
extern int    MovAMode =       2; //     /: 
                                  //  0 -  ;
                                  //  1 - - ;
                                  //  2 - - ;
// ----
extern int    CalcMeth =       0; //   :
                                  //  0 -     
                                  //      (  -    );
                                  //  1 -      
                                  //       ( SUMT + ''   )
                                  //      (  -      )
// ----
// ---- variables
int    NSize  = 5; //  ;    ;
int    TFrame = 0; // -,     ;
double CPoint = 0; //  ,     
//
// ---- user arrays
double Pairs [ ], Index [ ];                                  //   DLL
double ixUSD [ ], ixEUR [ ], ixGBP [ ], ixCHF [ ], ixJPY [ ]; //  
//
// ---- indicator buffers
double BufUSD [ ], BufEUR [ ], BufGBP [ ], BufCHF [ ], BufJPY [ ];
//
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//
int init ( )
  {   
    CPoint = Point; //    
    //   ,    ;
    //     
    if ( ValPoint >= 0.000001 ) // 1.0e-06
      {
        if ( CPoint > ValPoint ) { CPoint = ValPoint; }
      } // if ( ValPoint > 0.000001 )
    //  -,     ,
    //   ,    
    switch ( Period ( ) )
      {
        case   1 : { TFrame = PERIOD_M1 ; } break;
        case   5 : { TFrame = PERIOD_M5 ; } break;
        case  15 : { TFrame = PERIOD_M15; } break;
        case  30 : { TFrame = PERIOD_M30; } break;
        case  60 : { TFrame = PERIOD_H1 ; } break;
        case 240 : { TFrame = PERIOD_H4 ; } break;
        default  : { TFrame =         0 ; }
      } // switch ( Period ( ) )
  // ---- user arrays
    ArrayResize     ( Index,           NSize   );
    ArrayInitialize ( Index,             0.0   );
    //
    ArrayResize     ( Pairs, ( NSize * NSize ) );
    ArrayInitialize ( Pairs,             0.0   );
    //
    ArrayResize     ( ixUSD,        HistBars   );
    ArrayInitialize ( ixUSD,             0.0   );
    //
    ArrayResize     ( ixEUR,        HistBars   );
    ArrayInitialize ( ixEUR,             0.0   );
    //
    ArrayResize     ( ixGBP,        HistBars   );
    ArrayInitialize ( ixGBP,             0.0   );
    //
    ArrayResize     ( ixCHF,        HistBars   );
    ArrayInitialize ( ixCHF,             0.0   );
    //
    ArrayResize     ( ixJPY,        HistBars   );
    ArrayInitialize ( ixJPY,             0.0   );
  // ---- indicator buffers
    SetIndexLabel  ( 0, "Norm.USD" );
    SetIndexStyle  ( 0,  DRAW_LINE );
    SetIndexBuffer ( 0,     BufUSD );
    //
    SetIndexLabel  ( 1, "Norm.EUR" );
    SetIndexStyle  ( 1,  DRAW_LINE );
    SetIndexBuffer ( 1,     BufEUR );
    //
    SetIndexLabel  ( 2, "Norm.GBP" );
    SetIndexStyle  ( 2,  DRAW_LINE );
    SetIndexBuffer ( 2,     BufGBP );
    //
    SetIndexLabel  ( 3, "Norm.CHF" );
    SetIndexStyle  ( 3,  DRAW_LINE );
    SetIndexBuffer ( 3,     BufCHF );
    //
    SetIndexLabel  ( 4, "Norm.JPY" );
    SetIndexStyle  ( 4,  DRAW_LINE );
    SetIndexBuffer ( 4,     BufJPY );
  //----
    return ( 0 );
  } // int init ( )
//
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
//
int deinit ( )
  {
  //----
    Comment ( "" ); //      
  //----
    return ( 0 );
  } // int deinit ( )
//
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
//
//  Pairs [ ] (     );
//  i   ,  j -  : 
//
// |=======!=====!========!========!========!========!========!
// |   x   !  x  !  j=0   |  j=1   |  j=2   |  j=3   |  j=4   |
// |=======!=====!========|========|========|========|========|
// |   x   !  x  !  USD   |  EUR   |  GBP   |  CHF   |  JPY   |
// |=======!=====!========|========|========|========|========|
// |  i=0  ! USD !   -1   | EURUSD | GBPUSD |   -1   |   -1   |
// |-------!-----!--------|--------|--------|--------|--------|
// |  i=1  ! EUR !   -1   |   -1   |   -1   |   -1   |   -1   |
// |-------!-----!--------|--------|--------|--------|--------|
// |  i=2  ! GBP !   -1   | EURGBP |   -1   |   -1   |   -1   |
// |-------!-----!--------|--------|--------|--------|--------|
// |  i=3  ! CHF ! USDCHF | EURCHF | GBPCHF |   -1   |   -1   |
// |-------!-----!--------|--------|--------|--------|--------|
// |  i=4  | JPY ! USDJPY | EURJPY | GBPJPY | CHFJPY |   -1   |
// |=======!=====!========|========|========|========|========|
//
// , .., ,   EURGBP 'EUR' -  ( j = 1 ),
//  'GBP' -  ( i = 2 ).    
//     'USD', 'EUR', 'GBP', 'CHF', 'JPY' - . .
//  ,        
//  >= 1, ..     2;    2 x 2. 
//
//    N        ,
// , C ( N | 2 ) = N * ( N - 1 ) / 2  .   
//    ,   ,  , 
//   .
//
int start ( )
  {
    int i, j, k, m, res;
    //
    static int      NBars   = 0;
    static double   meanUSD = 0, meanEUR = 0, meanGBP = 0, meanCHF = 0, meanJPY = 0;
    static double   stddUSD = 0, stddEUR = 0, stddGBP = 0, stddCHF = 0, stddJPY = 0;
    static datetime LSTime  = 0, CSTime  = 0;
  // ----
    // -  4 (   
    //  ),   -    
    //          ,   
    //     :( , ,   
    //  ,    
    //  4       . :(
    if ( ( IsTesting ( ) ) || ( IsVisualMode ( ) ) ) return ( 0 ); 
    //
    //        ;
    // ,     ' ',
    //       :)
    SetIndexDrawBegin ( 0, ( Bars - HistBars ) );
    SetIndexDrawBegin ( 1, ( Bars - HistBars ) );
    SetIndexDrawBegin ( 2, ( Bars - HistBars ) );
    SetIndexDrawBegin ( 3, ( Bars - HistBars ) );
    SetIndexDrawBegin ( 4, ( Bars - HistBars ) );
    // 
    CSTime = TimeCurrent ( ); //     
    //         
    if ( ( NBars < Bars ) || ( ( CSTime - LSTime ) > Interval ) )    
      {      
        NBars  = Bars; //       
        //      
        LSTime = CSTime - MathMod ( ( CSTime - LSTime ), Interval ); 
        //               
        for ( m = HistBars - 1; m >= 0; m-- ) //    
          { 
            //                
            for ( i = 0; i <= NSize - 1; i++ )
              {
                for ( j = 0; j <= NSize - 1; j++ )
                  {
                    k = j + i * NSize; //    
                    Pairs [ k ] = -1;  //   
                    //   ;  . ;
                    //   , ,
                    // -,     :)
                    if ( ( i == 0 ) && ( j == 1 ) ) 
                      { Pairs [ k ] = iClose ( "EURUSD", TFrame, m ); }
                    if ( ( i == 0 ) && ( j == 2 ) ) 
                      { Pairs [ k ] = iClose ( "GBPUSD", TFrame, m ); }
                    if ( ( i == 2 ) && ( j == 1 ) ) 
                      { Pairs [ k ] = iClose ( "EURGBP", TFrame, m ); }
                    if ( ( i == 3 ) && ( j == 0 ) ) 
                      { Pairs [ k ] = iClose ( "USDCHF", TFrame, m ); }
                    if ( ( i == 3 ) && ( j == 1 ) ) 
                      { Pairs [ k ] = iClose ( "EURCHF", TFrame, m ); }
                    if ( ( i == 3 ) && ( j == 2 ) ) 
                      { Pairs [ k ] = iClose ( "GBPCHF", TFrame, m ); }
                    if ( ( i == 4 ) && ( j == 0 ) ) 
                      { Pairs [ k ] = iClose ( "USDJPY", TFrame, m ); }
                    if ( ( i == 4 ) && ( j == 1 ) ) 
                      { Pairs [ k ] = iClose ( "EURJPY", TFrame, m ); }
                    if ( ( i == 4 ) && ( j == 2 ) ) 
                      { Pairs [ k ] = iClose ( "GBPJPY", TFrame, m ); }
                    if ( ( i == 4 ) && ( j == 3 ) ) 
                      { Pairs [ k ] = iClose ( "CHFJPY", TFrame, m ); }
                  } // for ( j = 0; j < NSize; j++ )
              } // for ( i = 0; i < NSize; i++ )
            //
            //        CalcMeth:
            // 0 -        ; 
            // 1 -  SUMT-     
            res = MakeIndex ( CPoint, NSize, Pairs, CalcMeth );
            //
            //       
            if ( res == 0 ) // 'fool-proof' :)
              {
                //      DLL               
                for ( i = 0; i <= NSize - 1; i++ ) { Index [ i ] = GetAIndex ( i ); }
                //   
                ixUSD [ m ] = Index [ 0 ];
                ixEUR [ m ] = Index [ 1 ];
                ixGBP [ m ] = Index [ 2 ];
                ixCHF [ m ] = Index [ 3 ];
                ixJPY [ m ] = Index [ 4 ];
              }  // if ( res == 0 )
            else //    
              { 
                //                 
                for ( i = 0; i <= NSize - 1; i++ ) { Index [ i ] = 0.0; } 
                //        
                ixUSD [ m ] = ixUSD [ m + 1 ];
                ixEUR [ m ] = ixEUR [ m + 1 ];
                ixGBP [ m ] = ixGBP [ m + 1 ];
                ixCHF [ m ] = ixCHF [ m + 1 ];
                ixJPY [ m ] = ixJPY [ m + 1 ];                
              } // else                    
          } // for ( m = HistBars - 1; m >= 0; m-- )
        //        
        //   ,  ,    DLL
        //    ;      
        //       
        //     HistBars ( ' ' ) 
        //     
        ArrSmtNorm ( CPoint, HistBars, ixUSD, SmthMode, MovAMode );
        for ( m = HistBars - 1; m >= 0; m-- ) { BufUSD [ m ] = GetVNormal ( m ); }
        meanUSD = GetMeanVal ( ); //     DLL
        stddUSD = GetDStdDev ( ); //   '...'   DLL
        //
        ArrSmtNorm ( CPoint, HistBars, ixEUR, SmthMode, MovAMode );
        for ( m = HistBars - 1; m >= 0; m-- ) { BufEUR [ m ] = GetVNormal ( m ); }
        meanEUR = GetMeanVal ( ); //     DLL
        stddEUR = GetDStdDev ( ); //   '...'   DLL
        // 
        ArrSmtNorm ( CPoint, HistBars, ixGBP, SmthMode, MovAMode );
        for ( m = HistBars - 1; m >= 0; m-- ) { BufGBP [ m ] = GetVNormal ( m ); }
        meanGBP = GetMeanVal ( ); //     DLL
        stddGBP = GetDStdDev ( ); //   '...'   DLL
        //
        ArrSmtNorm ( CPoint, HistBars, ixCHF, SmthMode, MovAMode );
        for ( m = HistBars - 1; m >= 0; m-- ) { BufCHF [ m ] = GetVNormal ( m ); }
        meanCHF = GetMeanVal ( ); //     DLL
        stddCHF = GetDStdDev ( );//   '...'   DLL
        //
        ArrSmtNorm ( CPoint, HistBars, ixJPY, SmthMode, MovAMode );
        for ( m = HistBars - 1; m >= 0; m-- ) { BufJPY [ m ] = GetVNormal ( m ); }
        meanJPY = GetMeanVal ( ); //     DLL
        stddJPY = GetDStdDev ( );//   '...'   DLL
      } // if ( ( NBars < Bars ) || ( ( TimeCurrent ( ) - LSTime ) > Interval ) )
    //   
    Comment ( ": Res = ", res, /*"; FVal = ", GetFValue ( ), "; Iter = ", GetNNIter ( ),*/ "\n",
              "; MeanUSD = ", meanUSD, "; StdDUSD = ", stddUSD, "\n",
              "; MeanEUR = ", meanEUR, "; StdDEUR = ", stddEUR, "\n",
              "; MeanGBP = ", meanGBP, "; StdDGBP = ", stddGBP, "\n",
              "; MeanCHF = ", meanCHF, "; StdDCHF = ", stddCHF, "\n",
              "; MeanJPY = ", meanJPY, "; StdDJPY = ", stddJPY ); //     :) 
  // ----
    return ( 0 );
  } // int start ( )
//+------------------------------------------------------------------+